Index: branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icedyn.F90
===================================================================
--- branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icedyn.F90	(revision 8531)
+++ branches/2017/dev_r8183_ICEMODEL/NEMOGCM/NEMO/LIM_SRC_3/icedyn.F90	(revision 8534)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                     ***  MODULE  icedyn  ***
-   !!   Sea-Ice dynamics :  
+   !!   Sea-Ice dynamics : master routine for sea ice dynamics 
    !!======================================================================
    !! history :  4.0  ! 2017-09  (C. Rousset)  original code 
@@ -8,23 +8,23 @@
 #if defined key_lim3
    !!----------------------------------------------------------------------
-   !!   'key_lim3'                                       LIM3 sea-ice model
+   !!   'key_lim3'                                       ESIM sea-ice model
    !!----------------------------------------------------------------------
    !!   ice_dyn       : dynamics of sea ice
-   !!   ice_dyn_init  : initialisation of sea-ice dynamics
+   !!   ice_dyn_init  : initialization and namelist read
    !!----------------------------------------------------------------------
    USE phycst         ! physical constants
    USE dom_oce        ! ocean space and time domain
    USE ice            ! sea-ice: variables
-   USE icerhg         ! sea-ice: rheology
-   USE iceadv         ! sea-ice: advection
-   USE icerdgrft      ! sea-ice: ridging/rafting
+   USE icedyn_rhg     ! sea-ice: rheology
+   USE icedyn_adv     ! sea-ice: advection
+   USE icedyn_rdgrft  ! sea-ice: ridging/rafting
    USE icecor         ! sea-ice: corrections
    USE icevar         ! sea-ice: operations
    !
-   USE lbclnk         ! lateral boundary conditions - MPP exchanges
+   USE in_out_manager ! I/O manager
+   USE iom            ! I/O manager library
    USE lib_mpp        ! MPP library
-   USE in_out_manager ! I/O manager
-   USE iom            ! I/O manager
-   USE lib_fortran    ! glob_sum
+   USE lib_fortran    ! fortran utilities (glob_sum + no signed zero)
+   USE lbclnk         ! lateral boundary conditions (or mpp links)
    USE timing         ! Timing
 
@@ -73,5 +73,5 @@
       !!--------------------------------------------------------------------
       !
-      IF( nn_timing == 1 )  CALL timing_start('icedyn')
+      IF( nn_timing == 1 )   CALL timing_start('icedyn')
       !
       IF( kt == nit000 .AND. lwp ) THEN
@@ -104,19 +104,19 @@
 
       CASE ( np_dynFULL )          !==  all dynamical processes  ==!
-         CALL ice_rhg   ( kt )                            ! -- rheology  
-         CALL ice_adv   ( kt )   ;   CALL Hbig( zhmax )   ! -- advection of ice + correction on ice thickness
-         CALL ice_rdgrft( kt )                            ! -- ridging/rafting 
-         CALL ice_cor   ( kt , 1 )                        ! -- Corrections
+         CALL ice_dyn_rhg   ( kt )                            ! -- rheology  
+         CALL ice_dyn_adv   ( kt )   ;   CALL Hbig( zhmax )   ! -- advection of ice + correction on ice thickness
+         CALL ice_dyn_rdgrft( kt )                            ! -- ridging/rafting 
+         CALL ice_cor       ( kt , 1 )                        ! -- Corrections
 
       CASE ( np_dynRHGADV1 )       !==  no ridge/raft ==!   (mono cat. case 2)
-         CALL ice_rhg   ( kt )                            ! -- rheology  
-         CALL ice_adv   ( kt )                            ! -- advection of ice
-         CALL Hpiling                                     ! -- simple pile-up (replaces ridging/rafting)
-         CALL ice_cor   ( kt , 1 )                        ! -- Corrections
+         CALL ice_dyn_rhg   ( kt )                            ! -- rheology  
+         CALL ice_dyn_adv   ( kt )                            ! -- advection of ice
+         CALL Hpiling                                         ! -- simple pile-up (replaces ridging/rafting)
+         CALL ice_cor       ( kt , 1 )                        ! -- Corrections
 
       CASE ( np_dynRHGADV2 )       !==  no ridge/raft & no corrections ==!
-         CALL ice_rhg   ( kt )                            ! -- rheology  
-         CALL ice_adv   ( kt )                            ! -- advection of ice
-         CALL Hpiling                                     ! -- simple pile-up (replaces ridging/rafting)
+         CALL ice_dyn_rhg   ( kt )                            ! -- rheology  
+         CALL ice_dyn_adv   ( kt )                            ! -- advection of ice
+         CALL Hpiling                                         ! -- simple pile-up (replaces ridging/rafting)
 
       CASE ( np_dynADV )           !==  pure advection ==!   (prescribed velocities)
@@ -125,5 +125,5 @@
          !!CALL RANDOM_NUMBER(u_ice(:,:))
          !!CALL RANDOM_NUMBER(v_ice(:,:))
-         CALL ice_adv   ( kt )                            ! -- advection of ice
+         CALL ice_dyn_adv   ( kt )                            ! -- advection of ice
 
       END SELECT
@@ -269,7 +269,7 @@
       IF( .NOT. ln_landfast )   tau_icebfr(:,:) = 0._wp
       !
-      CALL ice_rdgrft_init          ! set ice ridging/rafting parameters
-      CALL ice_rhg_init             ! set ice rheology parameters
-      CALL ice_adv_init             ! set ice advection parameters
+      CALL ice_dyn_rdgrft_init          ! set ice ridging/rafting parameters
+      CALL ice_dyn_rhg_init             ! set ice rheology parameters
+      CALL ice_dyn_adv_init             ! set ice advection parameters
       !
    END SUBROUTINE ice_dyn_init
@@ -277,5 +277,5 @@
 #else
    !!----------------------------------------------------------------------
-   !!   Default option         Empty module          NO LIM-3 sea-ice model
+   !!   Default option         Empty module           NO ESIM sea-ice model
    !!----------------------------------------------------------------------
 #endif 