Index: branches/NERC/dev_r5518_GO6_package_trdtrc/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml
===================================================================
--- branches/NERC/dev_r5518_GO6_package_trdtrc/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 8549)
+++ branches/NERC/dev_r5518_GO6_package_trdtrc/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 8557)
@@ -1287,5 +1287,6 @@
        <field field_ref="ZDP_ALK"      name="ZDP_ALK"   />
        <field field_ref="ZDP_OXY"      name="ZDP_OXY"   />
-       <!-- trd case: jptra_dmp -->   
+       <!-- trd case: jptra_dmp --> 
+       <!-- NO DAMPING IN MEDUSA - COMMENT DO AVOID NaN  
        <field field_ref="DMP_CHN"      name="DMP_CHN"   />
        <field field_ref="DMP_CHD"      name="DMP_CHD"   />
@@ -1302,5 +1303,5 @@
        <field field_ref="DMP_DiC"      name="DMP_DiC"   />
        <field field_ref="DMP_ALK"      name="DMP_ALK"   />
-       <field field_ref="DMP_OXY"      name="DMP_OXY"   />
+       <field field_ref="DMP_OXY"      name="DMP_OXY"   /> -->
        <!-- trd case: jptra_sms -->
        <field field_ref="SMS_CHN"      name="SMS_CHN"   />
@@ -1413,5 +1414,5 @@
           <field field_ref="ZDF_CFC11"     name="ZDF_CFC11"     standard_name="CFC-11_Concentration"                  />
           <field field_ref="ZDP_CFC11"     name="ZDP_CFC11"     standard_name="CFC-11_Concentration"                  />
-          <field field_ref="DMP_CFC11"     name="DMP_CFC11"     standard_name="CFC-11_Concentration"                  />
+          <!-- <field field_ref="DMP_CFC11"     name="DMP_CFC11"     standard_name="CFC-11_Concentration"             /> -->
           <field field_ref="SMS_CFC11"     name="SMS_CFC11"     standard_name="CFC-11_Concentration"                  />
           <field field_ref="SMS_CFC11_INV" name="SMS_CFC11_INV" standard_name="CFC-11_Concentration"                  />
@@ -1434,5 +1435,5 @@
           <field field_ref="ZDF_CFC12"     name="ZDF_CFC12"     standard_name="CFC-12_Concentration"                  />
           <field field_ref="ZDP_CFC12"     name="ZDP_CFC12"     standard_name="CFC-12_Concentration"                  />
-          <field field_ref="DMP_CFC12"     name="DMP_CFC12"     standard_name="CFC-12_Concentration"                  />
+          <!-- <field field_ref="DMP_CFC12"     name="DMP_CFC12"     standard_name="CFC-12_Concentration"             /> -->
           <field field_ref="SMS_CFC12"     name="SMS_CFC12"     standard_name="CFC-12_Concentration"                  />
           <field field_ref="SMS_CFC12_INV" name="SMS_CFC12_INV" standard_name="CFC-12_Concentration"                  />
@@ -1455,5 +1456,5 @@
           <field field_ref="ZDF_SF6"      name="ZDF_SF6"      standard_name="SF6_Concentration"                     />
           <field field_ref="ZDP_SF6"      name="ZDP_SF6"      standard_name="SF6_Concentration"                     />
-          <field field_ref="DMP_SF6"      name="DMP_SF6"      standard_name="SF6_Concentration"                     />
+          <!-- <field field_ref="DMP_SF6"      name="DMP_SF6"      standard_name="SF6_Concentration"                /> -->
           <field field_ref="SMS_SF6"      name="SMS_SF6"      standard_name="SF6_Concentration"                     />
           <field field_ref="SMS_SF6_INV"  name="SMS_SF6_INV"  standard_name="SF6_Concentration"                     />
@@ -1476,5 +1477,5 @@
           <field field_ref="ZDF_Age"      name="ZDF_Age"      standard_name="sea_water_age_since_surface_contact"   />
           <field field_ref="ZDP_Age"      name="ZDP_Age"      standard_name="sea_water_age_since_surface_contact"   />
-          <field field_ref="DMP_Age"      name="DMP_Age"      standard_name="sea_water_age_since_surface_contact"   />
+          <!-- <field field_ref="DMP_Age"      name="DMP_Age"      standard_name="sea_water_age_since_surface_contact" /> -->
           <field field_ref="SMS_Age"      name="SMS_Age"      standard_name="sea_water_age_since_surface_contact"   />
           <field field_ref="SMS_Age_INV"  name="SMS_Age_INV"  standard_name="sea_water_age_since_surface_contact"   />
@@ -1497,5 +1498,5 @@
           <field field_ref="ZDF_IDTRA"      name="ZDF_IDTRA"      standard_name="IDTRA_Concentration"               />
           <field field_ref="ZDP_IDTRA"      name="ZDP_IDTRA"      standard_name="IDTRA_Concentration"               />
-          <field field_ref="DMP_IDTRA"      name="DMP_IDTRA"      standard_name="IDTRA_Concentration"               />
+          <!-- <field field_ref="DMP_IDTRA"      name="DMP_IDTRA"      standard_name="IDTRA_Concentration"          /> -->
           <field field_ref="SMS_IDTRA"      name="SMS_IDTRA"      standard_name="IDTRA_Concentration"               />
           <field field_ref="SMS_IDTRA_INV"  name="SMS_IDTRA_INV"  standard_name="IDTRA_Concentration"               />
@@ -1518,5 +1519,5 @@
           <field field_ref="ZDF_C14B"      name="ZDF_C14B"      standard_name="C14b_Concentration"               />
           <field field_ref="ZDP_C14B"      name="ZDP_C14B"      standard_name="C14b_Concentration"               />
-          <field field_ref="DMP_C14B"      name="DMP_C14B"      standard_name="C14b_Concentration"               />
+          <!-- <field field_ref="DMP_C14B"      name="DMP_C14B"      standard_name="C14b_Concentration"          /> -->
           <field field_ref="SMS_C14B"      name="SMS_C14B"      standard_name="C14b_Concentration"               />
           <field field_ref="SMS_C14B_INV"  name="SMS_C14B_INV"  standard_name="C14b_Concentration"               />
Index: branches/NERC/dev_r5518_GO6_package_trdtrc/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- branches/NERC/dev_r5518_GO6_package_trdtrc/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 8549)
+++ branches/NERC/dev_r5518_GO6_package_trdtrc/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 8557)
@@ -68,5 +68,5 @@
       CHARACTER (len=22) :: charout
       REAL(wp), POINTER, DIMENSION(:,:  ) :: zsfx
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrtrd
+      REAL(wp), POINTER, DIMENSION(:,:  ) :: ztrtrd
 
       !!---------------------------------------------------------------------
@@ -76,5 +76,5 @@
       ! Allocate temporary workspace
                       CALL wrk_alloc( jpi, jpj,      zsfx   )
-      IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj, jpk, ztrtrd )
+      IF( l_trdtrc )  CALL wrk_alloc( jpi, jpj,      ztrtrd )
       !
       zrtrn = 1.e-15_wp
@@ -140,5 +140,5 @@
       DO jn = 1, jptra
          !
-         IF( l_trdtrc ) ztrtrd(:,:,:) = tra(:,:,:,jn)  ! save trends
+         IF( l_trdtrc ) ztrtrd(:,:) = tra(:,:,1,jn)  ! save trends
          !                                             ! add the trend to the general tracer trend
 
@@ -184,5 +184,5 @@
          !
          IF( l_trdtrc ) THEN
-            ztrtrd(:,:,:) = tra(:,:,:,jn) - ztrtrd(:,:,:)
+            ztrtrd(:,:) = tra(:,:,1,jn) - ztrtrd(:,:)
             CALL trd_tra( kt, 'TRC', jn, jptra_nsr, ztrtrd )
          END IF
@@ -207,6 +207,6 @@
                                            CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       ENDIF
-                      CALL wrk_dealloc( jpi, jpj,      zsfx   )
-      IF( l_trdtrc )  CALL wrk_dealloc( jpi, jpj, jpk, ztrtrd )
+                      CALL wrk_dealloc( jpi, jpj, zsfx   )
+      IF( l_trdtrc )  CALL wrk_dealloc( jpi, jpj, ztrtrd )
       !
       IF( nn_timing == 1 )  CALL timing_stop('trc_sbc')