Index: branches/NERC/dev_r5518_GO6_package_trdtrc/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml
===================================================================
--- branches/NERC/dev_r5518_GO6_package_trdtrc/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 8558)
+++ branches/NERC/dev_r5518_GO6_package_trdtrc/NEMOGCM/CONFIG/SHARED/field_def_bgc.xml	(revision 8560)
@@ -676,19 +676,19 @@
        <field id="BBL_OXY"      long_name="dissolved oxygen"                                  unit="mmolO2/m3/s" />
        <!-- trd case: jptra_nsr -->
-       <field id="FOR_CHN"      long_name="Chl-a concentration in non-diatom phytoplankton"   unit="mg Chl/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_CHD"      long_name="Chl-a concentration in     diatom phytoplankton"   unit="mg Chl/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_PHN"      long_name="non-diatom phytoplankton"                          unit="mmol-N/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_PHD"      long_name="diatom     phytoplankton"                          unit="mmol-N/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_ZMI"      long_name="micro zooplankton"                                 unit="mmol-N/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_ZME"      long_name="meso  zooplankton"                                 unit="mmol-N/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_DIN"      long_name="dissolved inorganic nitrogen"                      unit="mmol-N/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_SIL"      long_name="dissolved silicic acid"                            unit="mmolSi/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_FER"      long_name="dissolved iron"                                    unit="mmolFe/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_DET"      long_name="detrital nitrogen"                                 unit="mmol-N/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_PDS"      long_name="biogenic silicon in diatom phytoplankton"          unit="mmolSi/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_DTC"      long_name="detrital carbon"                                   unit="mmol-C/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_DiC"      long_name="dissolved inorganic carbon"                        unit="mmol-C/m3/s" grid_ref="grid_T_2D" />
-       <field id="FOR_ALK"      long_name="alkalinity"                                        unit="meq/m3/s"    grid_ref="grid_T_2D" />
-       <field id="FOR_OXY"      long_name="dissolved oxygen"                                  unit="mmolO2/m3/s" grid_ref="grid_T_2D" />
+       <field id="FOR_CHN"      long_name="Chl-a concentration in non-diatom phytoplankton"   unit="mg Chl/m3/s"  />
+       <field id="FOR_CHD"      long_name="Chl-a concentration in     diatom phytoplankton"   unit="mg Chl/m3/s"  />
+       <field id="FOR_PHN"      long_name="non-diatom phytoplankton"                          unit="mmol-N/m3/s"  />
+       <field id="FOR_PHD"      long_name="diatom     phytoplankton"                          unit="mmol-N/m3/s"  />
+       <field id="FOR_ZMI"      long_name="micro zooplankton"                                 unit="mmol-N/m3/s"  />
+       <field id="FOR_ZME"      long_name="meso  zooplankton"                                 unit="mmol-N/m3/s"  />
+       <field id="FOR_DIN"      long_name="dissolved inorganic nitrogen"                      unit="mmol-N/m3/s"  />
+       <field id="FOR_SIL"      long_name="dissolved silicic acid"                            unit="mmolSi/m3/s"  />
+       <field id="FOR_FER"      long_name="dissolved iron"                                    unit="mmolFe/m3/s"  />
+       <field id="FOR_DET"      long_name="detrital nitrogen"                                 unit="mmol-N/m3/s"  />
+       <field id="FOR_PDS"      long_name="biogenic silicon in diatom phytoplankton"          unit="mmolSi/m3/s"  />
+       <field id="FOR_DTC"      long_name="detrital carbon"                                   unit="mmol-C/m3/s"  />
+       <field id="FOR_DiC"      long_name="dissolved inorganic carbon"                        unit="mmol-C/m3/s"  />
+       <field id="FOR_ALK"      long_name="alkalinity"                                        unit="meq/m3/s"     />
+       <field id="FOR_OXY"      long_name="dissolved oxygen"                                  unit="mmolO2/m3/s"  />
        <!-- trd case: jptra_zdf -->
        <field id="ZDF_CHN"      long_name="Chl-a concentration in non-diatom phytoplankton"   unit="mg Chl/m3/s" />
@@ -905,5 +905,5 @@
        <field id="LDF_IDTRA"      long_name="Ideal traceur concentration "              unit="mmol/m3/s"    />
        <field id="BBL_IDTRA"      long_name="Ideal traceur concentration "              unit="mmol/m3/s"    />
-       <field id="FOR_IDTRA"      long_name="Ideal traceur concentration "              unit="mmol/m3/s"    grid_ref="grid_T_2D" />
+       <field id="FOR_IDTRA"      long_name="Ideal traceur concentration "              unit="mmol/m3/s"    />
        <field id="ZDF_IDTRA"      long_name="Ideal traceur concentration "              unit="mmol/m3/s"    />
        <field id="ZDP_IDTRA"      long_name="Ideal traceur concentration "              unit="mmol/m3/s"    />
@@ -929,5 +929,5 @@
        <field id="LDF_CFC11"       long_name="CFC-11 Concentration"                     unit="umol/m3/s" />
        <field id="BBL_CFC11"       long_name="CFC-11 Concentration"                     unit="umol/m3/s" />
-       <field id="FOR_CFC11"       long_name="CFC-11 Concentration"                     unit="umol/m3/s" grid_ref="grid_T_2D" />
+       <field id="FOR_CFC11"       long_name="CFC-11 Concentration"                     unit="umol/m3/s" />
        <field id="ZDF_CFC11"       long_name="CFC-11 Concentration"                     unit="umol/m3/s" />
        <field id="ZDP_CFC11"       long_name="CFC-11 Concentration"                     unit="umol/m3/s" />
@@ -952,5 +952,5 @@
        <field id="LDF_CFC12"       long_name="CFC-12 Concentration"                     unit="umol/m3/s" />
        <field id="BBL_CFC12"       long_name="CFC-12 Concentration"                     unit="umol/m3/s" />
-       <field id="FOR_CFC12"       long_name="CFC-12 Concentration"                     unit="umol/m3/s" grid_ref="grid_T_2D" />
+       <field id="FOR_CFC12"       long_name="CFC-12 Concentration"                     unit="umol/m3/s" />
        <field id="ZDF_CFC12"       long_name="CFC-12 Concentration"                     unit="umol/m3/s" />
        <field id="ZDP_CFC12"       long_name="CFC-12 Concentration"                     unit="umol/m3/s" />
@@ -975,5 +975,5 @@
        <field id="LDF_SF6"         long_name="SF6 Concentration"                        unit="umol/m3/s" />
        <field id="BBL_SF6"         long_name="SF6 Concentration"                        unit="umol/m3/s" />
-       <field id="FOR_SF6"         long_name="SF6 Concentration"                        unit="umol/m3/s" grid_ref="grid_T_2D" />
+       <field id="FOR_SF6"         long_name="SF6 Concentration"                        unit="umol/m3/s" />
        <field id="ZDF_SF6"         long_name="SF6 Concentration"                        unit="umol/m3/s" />
        <field id="ZDP_SF6"         long_name="SF6 Concentration"                        unit="umol/m3/s" />
@@ -998,5 +998,5 @@
        <field id="LDF_C14B"        long_name="Bomb C14 Concentration"                   unit="1/s"         />
        <field id="BBL_C14B"        long_name="Bomb C14 Concentration"                   unit="1/s"         />
-       <field id="FOR_C14B"        long_name="Bomb C14 Concentration"                   unit="1/s" grid_ref="grid_T_2D" />
+       <field id="FOR_C14B"        long_name="Bomb C14 Concentration"                   unit="1/s"         />
        <field id="ZDF_C14B"        long_name="Bomb C14 Concentration"                   unit="1/s"         />
        <field id="ZDP_C14B"        long_name="Bomb C14 Concentration"                   unit="1/s"         />
@@ -1021,5 +1021,5 @@
        <field id="LDF_Age"        long_name="Sea Water Age Since Surface contact" standard_name="sea_water_age_since_surface_contact"  unit="yr/s"         />
        <field id="BBL_Age"        long_name="Sea Water Age Since Surface contact" standard_name="sea_water_age_since_surface_contact"  unit="yr/s"         />
-       <field id="FOR_Age"        long_name="Sea Water Age Since Surface contact" standard_name="sea_water_age_since_surface_contact"  unit="yr/s"    grid_ref="grid_T_2D"  />
+       <field id="FOR_Age"        long_name="Sea Water Age Since Surface contact" standard_name="sea_water_age_since_surface_contact"  unit="yr/s"         />
        <field id="ZDF_Age"        long_name="Sea Water Age Since Surface contact" standard_name="sea_water_age_since_surface_contact"  unit="yr/s"         />
        <field id="ZDP_Age"        long_name="Sea Water Age Since Surface contact" standard_name="sea_water_age_since_surface_contact"  unit="yr/s"         />